
function macro(){
	var mc = this;
	var id;
	var video;
	var web;
	var blog;
	var news;
	var local;
	var localPlace;
	var initialPhrase;
	var searcherControl
	var searcherState;
	var linkTarget;
	this.cse;
}

function custom(enable, value){
	this.enable = enable;
	this.tag = value;
	this.setEnable = setEnable;
	this.setValue = setValue;
}

function setEnable(val){
	this.enable.attr('checked', val);
	if(val){
		//alert(val);
		this.tag.attr('disabled',false);
	}
	else{
		this.tag.attr('disabled',true);
	}
	reload_macro_text();
}

function setValue(val){
	this.tag.val(val);
	reload_macro_text();
}


$( function() {
	
	new macro();
	macro.id = $('#googleajaxsearch_id');
	macro.video = $('#googleajaxsearch_searcher_video');
	macro.web = $('#googleajaxsearch_searcher_web');
	macro.blog = $('#googleajaxsearch_searcher_blog');
	macro.news = $('#googleajaxsearch_searcher_news');
	macro.local = $('#googleajaxsearch_searcher_local');
	macro.localPlace = $('#googleajaxsearch_local_place');
	macro.initialPhrase = $('#googleajaxsearch_phrase');
	macro.searcherControl = $('#searcher_control_mode');
	macro.searcherState = $('#searcher_default_state');
	macro.linkTarget = $('#searcher_link_target');
	macro.cse = new Object();
	macro.cse.web = new custom($('#enable_cse_web'),$('#cse_web'));
	macro.cse.news = new custom($('#enable_cse_news'),$('#cse_news'));
	macro.cse.blog = new custom($('#enable_cse_blog'),$('#cse_blog'));
	macro.newsOrder=$('#searcher_news_order');
	macro.blogOrder=$('#searcher_blog_order');
	macro.id.attr("onchange", "set_googleajaxsearch_value(macro.id, this.value)");
	macro.video.attr("onchange", "set_googleajaxsearch_checked(macro.video, this.checked)");
	macro.web.attr("onchange", "set_googleajaxsearch_checked(macro.web, this.checked)");
	macro.blog.attr("onchange", "set_googleajaxsearch_checked(macro.blog, this.checked)");
	macro.news.attr("onchange", "set_googleajaxsearch_checked(macro.news, this.checked)");
	macro.local.attr("onchange", "set_googleajaxsearch_checked(macro.local, this.checked)");
	macro.localPlace.attr("onchange", "set_googleajaxsearch_value(macro.localPlace, this.value)");
	macro.initialPhrase.attr("onchange", "set_googleajaxsearch_value(macro.initialPhrase, this.value)");
	macro.searcherControl.attr("onchange", "set_googleajaxsearch_value(macro.searcherControl, this.value)");
	macro.searcherState.attr("onchange", "set_googleajaxsearch_value(macro.searcherState, this.value)");
	macro.linkTarget.attr("onchange", "set_googleajaxsearch_value(macro.linkTarget, this.value)");
	macro.cse.web.enable.attr("onchange", "macro.cse.web.setEnable(this.checked)");
	macro.cse.web.tag.attr("onchange", "macro.cse.web.setValue(this.value)");
	macro.cse.news.enable.attr("onchange", "macro.cse.news.setEnable(this.checked)");
	macro.cse.news.tag.attr("onchange", "macro.cse.news.setValue(this.value)");
	macro.cse.blog.enable.attr("onchange", "macro.cse.blog.setEnable(this.checked)");
	macro.cse.blog.tag.attr("onchange", "macro.cse.blog.setValue(this.value)");
	macro.newsOrder.attr("onchange", "set_googleajaxsearch_value(macro.newsOrder, this.value)");
	macro.blogOrder.attr("onchange", "set_googleajaxsearch_value(macro.blogOrder, this.value)");
	$('#macro_text').val(gajax_to_macro(macro));
});

function gajax_to_macro(obj){
	
	var id = obj.id.attr('value') != '' ? '|resultid=' + obj.id.attr('value') : '';
	var video = obj.video.attr('checked') ? '|searcher=video' : '';
	var web = obj.web.attr('checked') ? '|searcher=web' : '';
	var blog = obj.blog.attr('checked') ? '|searcher=blog' : '';
	var news = obj.news.attr('checked') ? '|searcher=news' : '';
	var local = obj.local.attr('checked') ? '|searcher=local' : '';
	var place = (obj.localPlace.attr('value') != '' && obj.local.attr('checked')) ? '|place=' + obj.localPlace.attr('value') : '';
	var initialsearch = obj.initialPhrase.attr('value') != '' ? '|initialsearch=' + obj.initialPhrase.attr('value') : '';
	
	var control = new String('|mode=');
	switch(obj.searcherControl.attr('value')){
		case '0':
			control += 'linear';
			break;
		case '1':
			control += 'tabbed';
			break;
	}
	
	var bsorder=new String('|bsorder=');
	switch(obj.blogOrder.attr('value')){
		case '0':
			bsorder += 'relevance';
			break;
		case '1':
			bsorder += 'date';
			break;
	}
	
	var nsorder=new String('|nsorder=');
	switch(obj.newsOrder.attr('value')){
		case '0':
			nsorder += 'relevance';
			break;
		case '1':
			nsorder += 'date';
			break;
	}
	
	var state = new String('|state=');
	switch(obj.searcherState.attr('value')){
		case '0':
			state += 'open';
			break;
		case '1':
			state += 'closed';
			break;
		case '2':
			state += 'partial';
			break;
	}
	var target = new String('|target=');
	switch(obj.linkTarget.attr('value')){
		case '0':
			target +='blank';
			break;
		case '1':
			target +='self';
			break;
		case '2':
			target += 'top';
			break;
		case '3':
			target += 'parent';
			break;
	}
	var cseWeb = '';
	if(obj.cse.web.enable.attr('checked')){
		if(obj.cse.web.tag.attr('value')){
			cseWeb = '|cseWeb=' + obj.cse.web.tag.attr('value');
		}
	}
	var cseNews = '';
	if(obj.cse.news.enable.attr('checked')){
		if(obj.cse.news.tag.attr('value')){
			cseNews = '|cseNews=' + obj.cse.news.tag.attr('value');
		}
	}
	var cseBlog = '';
	if(obj.cse.blog.enable.attr('checked')){
		if(obj.cse.blog.tag.attr('value')){
			cseBlog = '|cseBlog=' + obj.cse.blog.tag.attr('value');
		}
	}
	return '[googleajaxsearch' + id + video + web + blog + news + local + place + initialsearch + control + state + target + cseWeb + cseNews + cseBlog + bsorder + nsorder +']';
}

function reload_macro_text(){
	$('#macro_text').val(gajax_to_macro(macro));
}

function set_googleajaxsearch_value(attr, value){
	attr.val(value);
	reload_macro_text();
}

function set_googleajaxsearch_checked(attr, value){
	attr.attr('checked', value);
	reload_macro_text();
}
